#include <GL\glut.h>
#include "Hoja.h"

//--------------------------------------------------------------------------------------------------------------------------------
// Void constructor
// Parameters --> None
//--------------------------------------------------------------------------------------------------------------------------------
Hoja::Hoja(void) 
{
	
	Vert_Hoja[0] = Vert_Hoja[1] = Vert_Hoja[2] = Vert_Hoja[3] = 0;
	Normal[0] = Normal[1] = Normal[2] = 0;
	padre=-1;
	Cuantas_hojas = 1;
	hijoi = hijod = -1;
	raiz= visible= -1;
//	prev = next = -1;
	
		
}


//--------------------------------------------------------------------------------------------------------------------------------
// Copy constructor
// Parameters --> const Hoja& aHoja : The Hoja to copy
//--------------------------------------------------------------------------------------------------------------------------------
Hoja::Hoja (const Hoja& aHoja)
{


	Cuantas_hojas = aHoja.Cuantas_hojas;;
	padre = aHoja.padre;
	hijoi = aHoja.hijoi;
	hijod = aHoja.hijod;
	visible = aHoja.visible;
	raiz = aHoja.raiz;
	
	for (int i = 0L; i < 4; i++)
		Vert_Hoja[i] = aHoja.Vert_Hoja[i]; 
	for ( i = 0L; i < 3; i++)
		Normal[i] = aHoja.Normal[i]; 
	

}



//--------------------------------------------------------------------------------------------------------------------------------
// Destructor. We must deallocate the memory allocated for pointers to Vert_Hoja and edges
//--------------------------------------------------------------------------------------------------------------------------------
Hoja::~Hoja (void)
{
}


