#ifndef FOLIAGE_H
#define FOLIAGE_H


#include "arbol.h"
#include "Activas.h"
//#include "material.h"
#include "tlista.h"
//#include <vl\VLf.h>
#include "TMatrix.h"



class Foliage
{
	public :

	Arbol	 *MiArbol;
	Activas  *Acth; // primera hoja activa
	int ppio, final;
	int nhactivas;
	TMatrix mat_aux;

	public :
		Foliage (void); // Void constructor
		Foliage ( Arbol* Arbol1 ); // Constructor with the name of a file cotaining the data
		virtual ~Foliage (void); // Destructor
		
		// sacar por pantalla
/*		void Dibuja_Hoja ( Hoja&);
		int  DibujarHojas (float frustum[6][4], float zoom);
		void DibujaEsfera (float);*/

		//culling
		void Culling (float frustum[6][4]);
		bool LeafinFrustum ( int i, float frustum[6][4]);
		
		// resolucion variable
		bool EsActivo (  int num);
		int  DondeEsta (  float x, float y, float z, float rva, float rvb,float rvc, float rvd);
		bool Criterio ( Hoja &aHoja, char ch, float rva, float rvb,float rvc, float rvd, float radio);
		int  ResolucionV ( char c, float rva, float rvb,float rvc, float rvd, float radio);
		void ColapsaHoja (int, int&);
		bool Forzar_Colapse (int hoja,  int &hpost,  char ch, float rva, float rvb,float rvc, float rvd, float radio);
		void SplitHoja (int, int&);
		int  Chequea_Split(int, char, float rva, float rvb,float rvc, float rvd, float radio);
		bool Forzar_Split(int, int, int&);
		int  AnteriorActivo (int h);
		int  PosteriorActivo (int h);


		// resolucion constante
		int  ResolucionC (float dist, float dmax, float dmin);
		void AjusteHojas( int nhojas);
		void RCecol (  int nhojas);
		void RCsplit (  int nhojas);

		//impostores
//		void DibujaCaja (float alfa, float d);
//		int  DibujaMediaCopa ( char c, float rva, float rvb,float rvc, float rvd, float radio);
		
};

#endif